(*
    ===========================================================================

    ---------------------------------------------------------------------------
    Gen's LowTech : bZ[WtbNg
    http://www2.biglobe.ne.jp/~sakai/usehook.htm
    http://www2.biglobe.ne.jp/~sakai/bin/list2.txt

    ---------------------------------------------------------------------------
    Using Hooks
    ms-help://MS.PSDK.1033/winui/winui/windowsuserinterface/windowing/hooks/usinghooks.htm


    ---------------------------------------------------------------------------
    2003/11/25  n
    2004/02/05  C(OƂ/)
    ===========================================================================
*)


unit HookMain;

interface

uses
    Windows, Messages, iFMO, misc;

(*
    ===========================================================================
    export
    ===========================================================================
*)

//  tbNCXg[
function    HookInstall(Wnd: HWND): Boolean; export; stdcall;

//  tbNACXg[
procedure   HookUnInstall(); export; stdcall;

implementation

(*
    ===========================================================================
    type
    ===========================================================================
*)

//  L̓eɂ\
type
    PShareHookInfo = ^TShareHookInfo;
    TShareHookInfo = packed record
        HostWindow : HWND;     //  ʒmEBhE
        HCbtHook   : HHOOK;    //  tbÑnh
        HMouseHook : HHOOK;    //  tbÑnh
    end;

//  tbN֐^
type
    THookProc = function(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;

//  LłȂeɂ\
type
    PLocalHookInfo = ^TLocalHookInfo;
    TLocalHookInfo = record
        CbtHooked  : Boolean;   //  tbNtO
        MouseHooked: Boolean;   //  tbNtO
        FmoHandle: THandle;     //  FMOnh
    end;

const
    //  MMF̃t@C
    FMO_NAME = '{1E2506E8-1E6D-45E1-B910-C96362648E40}';
var
    //  tbN֐̃CXg[Ɋւێ
    LHI: TLocalHookInfo;

(*
    ===========================================================================
    CBTProc
    ===========================================================================
*)
function    CBTProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;

    //  -------------------------------------------------
    //  _CAOǂ
    function    IsDialog(WH: integer): Boolean;
    begin
        Result := (GetClassNameStr(WH) = DLG_CLASS_NAME);
    end;
    //  -------------------------------------------------

var
    hFMO: THandle;
    p   : Pointer;
    Shi : PShareHookInfo;

    CreateWnd  : integer;
    DestroyWnd : integer;
begin
    //  MMFgp
    GetFileMappingObject(hFMO, p, FMO_NAME);
    //  tbN\̏
    Shi := PShareHookInfo(p);
    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        //  ܂ꂽăEBhE
        HCBT_CREATEWND:
            begin
                //  쐬EBhẼnh
                CreateWnd := wParam;
                //  ̃EBhEgbvEBhEǂ
                if (IsTopLevelWindow(CreateWnd)) then
                begin
                    //  _CAOH
                    if IsDialog(CreateWnd) then
                    begin
                        PostMessage(Shi^.HostWindow, UM_CREATEWND, CreateWnd, 0);
                    end;
                end;
            end;

        //  ɂEBhE
        HCBT_DESTROYWND:
            begin
                //  jEBhẼnh
                DestroyWnd := wParam;
                //  _CAOH
                if IsDialog(DestroyWnd) then
                begin
                    PostMessage(Shi^.HostWindow, UM_DESTROYWND, DestroyWnd, 0);
                end;
            end;

        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HCbtHook, nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    MouseProc
    ===========================================================================
*)
function    MouseProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;

    //  -------------------------------------------------
    //  ̃^C~Oǂ
    function    IsTimeing(AMsg: integer): Boolean;
    begin
        Result := (AMsg = WM_LBUTTONUP)
                  ;
    end;
    //  -------------------------------------------------

var
    hFMO: THandle;
    p   : Pointer;
    Shi : PShareHookInfo;
begin
    //  MMFgp
    GetFileMappingObject(hFMO, p, FMO_NAME);
    //  tbN\̏
    Shi := PShareHookInfo(p);
    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        //  }EXANV
        HC_ACTION:
            begin
                if IsTimeing(wParam) then
                begin
                    PostMessage(Shi^.HostWindow, UM_MOUSEACTION, 0, 0);
                end;
            end;

        else
            ;
        end;
    end;
    //  ̐l[
    Result := CallNextHookEx(Shi^.HMouseHook, nCode, wParam, lParam);
    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    tbNCXg[
    ===========================================================================
*)
function    HookInstall(Wnd: HWND): Boolean;
var
    hFMO: THandle;
    p: Pointer;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    GetFileMappingObject(hFMO, p, FMO_NAME);
    //  tbN\̏(邢͎擾)
    Shi := PShareHookInfo(p);
    try
        //  ʒmL^
        Shi^.HostWindow := Wnd;
        //  tbN֐̓o^-1
        Shi^.HCbtHook := SetWindowsHookEx(WH_CBT, CBTProc, HInstance, 0);
        //  tbN-1
        LHI.CbtHooked := (Shi^.HCbtHook > 0);
        //  tbN֐̓o^-2
        Shi^.HMouseHook := SetWindowsHookEx(WH_MOUSE, MouseProc, HInstance, 0);
        //  tbN-1
        LHI.MouseHooked := (Shi^.HMouseHook > 0);
    finally
        //  MMFgpI
        ReleaseFileMappingObject(hFMO, p);
    end;
    //  ?
    Result := LHI.CbtHooked and LHI.MouseHooked;
end;

(*
    ===========================================================================
    tbNACXg[
    ===========================================================================
*)
procedure   HookUnInstall();
var
    hFMO: THandle;
    p: Pointer;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    GetFileMappingObject(hFMO, p, FMO_NAME);
    //  tbN\̏
    Shi := PShareHookInfo(p);
    //  tbN-1
    if LHI.CbtHooked then
    begin
        UnhookWindowsHookEx(Shi^.HCbtHook);
    end;
    //  tbN-2
    if LHI.MouseHooked then
    begin
        UnhookWindowsHookEx(Shi^.HMouseHook);
    end;
    //  MMFgpI
    ReleaseFileMappingObject(hFMO, p);
end;

(******************************************************************************)

(*
    ===========================================================================
    initialization
    ===========================================================================
*)
initialization
begin
    //  MMF 쐬
    FillChar(LHI, SizeOf(LHI), #0);
    LHI.FmoHandle := CreateFileMappingObject(SizeOf(TShareHookInfo), FMO_NAME);
end;

(*
    ===========================================================================
    finalization
    ===========================================================================
*)
finalization
begin
    //  MMF 
    DestroyFileMappingObject(LHI.FmoHandle);
end;

end.

